/*
 * Programmieren fuer Physiker, SS 2023, Blatt 08, Aufgabe 21
 *
 * Sortieren einer double-Liste mit Quicksort
 */


#include <iostream>
#include <cstdlib>

using namespace std ;

void Tausche( double & a, double & b)
{
    double tmp = a ;
    a = b ;
    b = tmp ;
}

int Partition( double Liste[], const int s, const int t) 
// Partitioniert im Feld Liste zweischen s und t (einschliesslich)
// Rueckgabewert: die Position des Pivotelements
{
    double pivot=Liste[s] ; // nimm' einfach das erste Element...
    int l=s ;
    for( int i=s+1; i<=t; i++)
	if (Liste[i]<pivot)
	{
	    l++ ;
	    Tausche( Liste[i], Liste[l]) ;
	}
    Tausche( Liste[s], Liste[l]) ;
    return l ;
}
    
void QuickSort( double Liste[], const int s, const int t) 
// QuickSort:
// rekursives Sortieren durch Teilen in zwei Teilmengen
// Argumente: Liste und Indizes, zwischen denen sortiert wird.
{
    // nur noch 1 oder weniger Elemente? dann nichts mehr zu tun
    if (t<=s) return ;
 
    // erster Schritt:
    // Partitionierung
    int pivotindex=Partition( Liste, s, t) ;

    // zweiter Schritt:
    // sortiere die beiden Teilmengen rechts und links
    QuickSort( Liste, s, pivotindex-1) ;
    QuickSort( Liste, pivotindex+1, t) ;
}

void ListeQuickSortieren( int Anzahl, double Liste[]) 
{
    // Aufruf der rekursiven QuickSort-Routine mit Anfang- und End-Index
    QuickSort( Liste, 0, Anzahl-1) ;
}

void ListeAusgeben( int Anzahl, double Liste[]) 
{
    cout << "Laenge: " << Anzahl << endl ;
    cout << "Elemente: " ;
    for( int i=0; i<Anzahl; ++i) 
	cout << Liste[i] << "  " ;
    cout << endl ;
}

int main()
{
    const int Anzahl=1000 ;
    double Feld[Anzahl] ;

    // Feld mit zufaelligen Werten initialisieren
    // srand((unsigned int)time(0)) ;
    for( int i=0; i<Anzahl; i++)
	Feld[i] = rand()/double(RAND_MAX) ;

    cout << "Die unsortierte Liste:" << endl ;
    ListeAusgeben( Anzahl, Feld) ;
    cout << endl ; 

    ListeQuickSortieren( Anzahl, Feld) ;

    cout << "Die aufsteigend sortierte Liste:" << endl ;
    ListeAusgeben( Anzahl, Feld) ;
    cout << endl ;
}
